import { ShapeConfig } from '../components/annotator/types';
import { RectPointTuple } from './kie';

export interface Template {
  id: number;
  name: string;
  file_url: string;
  data_boxs: BoundingBox[];
  anchor_boxs: BoundingBox[];
  temp_name: string;
}

export interface TemplateWithShapes extends Template {
  shapes: ShapeConfig[];
}

export interface TemplateOcrResult {
  status: number;
  content: {
    [key: string]: string;
  };
}

export interface BoundingBox {
  id: number;
  name: string;
  coordinates: RectPointTuple<string>;
}
